using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

using Entities;

namespace Domain.Implementation
{
    public class Customer : BaseEntity, ICustomer
    {
        protected string name;
        public virtual string Name
        {
            get { return name; }
            set { name = value; }
        }

        public virtual float Discount { get { return 0.0F; } }

        protected float sumOfAllOrders;



        protected IList orders = new List<Order>();
        public virtual IEnumerable<IOrder> Orders
        {
            get
            {
                List<IOrder> result = new List<IOrder>(this.orders.Count);
                foreach (Order o in this.orders)
                    result.Add(o);

                return result;
            }
        }

        public virtual IOrder CreateOrder()
        {
            Order o = new Order();

            o.Customer = this;
            this.orders.Add(o);

            o.AmountChanged += delegate(object sender, OrderAmountChangedEventArgs e)
            {
                this.sumOfAllOrders += e.Delta;
            };

            return o;
        }
    }
}
